
// buttonListener must have 'actionPerformed' method

function createButton( element, label, buttonListener ) {
    //element.style.height = "40px";
    //element.setAttribute( "style", "position:relative;line-height:40px;-apple-dashboard-region:dashboard-region(control rectangle);" );

    var left = document.createElement( "div" );
    left.setAttribute( "style", "position:absolute;top:0px;left:0px;width:6px;height:16px;background:url(Images/ButtonLeft.png) top left;" );
    element.appendChild( left );
    var center = document.createElement( "div" );
    center.setAttribute( "style", "position:absolute;top:0px;left:6px;right:6px;bottom:0px;line-height:16px;background:url(Images/ButtonMiddle.png) repeat-x top left;text-align:center;color.white;" );
    if ( label.nodeType == 1 ) {
        center.appendChild( label );
    } else {
        center.appendChild( document.createTextNode( label ) );
    }
    element.appendChild( center );
    var right = document.createElement( "div" );
    right.setAttribute( "style", "position:absolute;top:0px;right:0px;width:6px;height:16px;background:url(Images/ButtonRight.png);" );
    element.appendChild( right );
    //debug( "listener " + buttonListener );
    if ( buttonListener ) {
        element.buttonListener = buttonListener;
    } else {
        element.buttonListener = _dummyButtonListener;
    }

    element.label = label;
    element.style.background = "none";
    //element.callback = callback;
    element.pushableButton = true;
    element.enabled = true;
    //element.addEventListener( "click", "debug('click')" );
    element.setAttribute( "onmousedown", "buttonDown(event,this);", true );

    // text colors
    element.textColor = "#222";//white";
    element.pushedColor = "#ddd"//#666";//#ddd";
    element.style.color = element.textColor;

    // control
    element.style.appleDashboardRegion = "dashboard-region(control rectangle)";// 5px 5px 5px 5px)";
//     right.style.appleDashboardRegion = "dashboard-region(control rectangle)";// 5px 5px 5px 5px)";
//     center.style.appleDashboardRegion = "dashboard-region(control rectangle)";// 5px 5px 5px 5px)";
//     left.style.appleDashboardRegion = "dashboard-region(control rectangle)";// 5px 5px 5px 5px)";
    //debug( element.style.appleDashboardRegion );

    // load images
    (new Image()).src = "Images/ButtonLeftActivated.png";
    (new Image()).src = "Images/ButtonMiddleActivated.png";
    (new Image()).src = "Images/ButtonRightActivated.png";
    return element;
}

function buttonDown( event, elem ) {
    //debug( "pushed " + event + " " + elem );//+ " " + elem.callback);
    if ( elem.pushableButton ) {
        var children = elem.childNodes;
        children[ 0 ].style.background ="url(Images/ButtonLeftActivated.png)";
        children[ 1 ].style.background ="url(Images/ButtonMiddleActivated.png) repeat-x";
        children[ 2 ].style.background ="url(Images/ButtonRightActivated.png)";
        children[ 1 ].style.color = elem.pushedColor;
        elem.setAttribute( "onmouseup", "buttonUp(event,this);" );
        elem.setAttribute( "onmouseout", "buttonOut(event,this);" );
    }
}
function buttonOut( event, elem ) {
    //debug( "out " + event + " " + elem );
    if ( elem.pushableButton ) {
        var children = elem.childNodes;
        children[ 0 ].style.background ="url(Images/ButtonLeft.png)";
        children[ 1 ].style.background ="url(Images/ButtonMiddle.png) repeat-x";
        children[ 2 ].style.background ="url(Images/ButtonRight.png)";
        children[ 1 ].style.color = elem.textColor;
        elem.removeAttribute( "onmouseup" );
        elem.removeAttribute( "onmouseout" );
    }
}

function buttonUp( event, elem ) {
    if ( elem.pushableButton ) {
        buttonOut( event, elem );
        if ( elem.buttonListener ) {
            elem.buttonListener.actionPerformed( event, elem );
        }
        //elem.callback( event, elem );
    }
}

function _ButtonAdapter() {
}
_ButtonAdapter.prototype.actionPerformed = function( event, element ) {
    var label = element.label;
    debug( "Push event " + label );
};
var _dummyButtonListener = new _ButtonAdapter();
